/**
 * CircumscribedTriangle creates a geometric logo with a triangle and 
 *    enclosing circle and square. 
 * It also computes and prints the areas of the three figures.
 *
 * @author kvlinden,snelesen
 * @version Fall, 2010
 */

final int UNIT = 300; 
int width = UNIT, height = width;
int squareX, squareY, squareWidth = width - 50;
int circleX, circleY, circleDiameter;

size(width, height);
smooth();
background(255);
strokeWeight(4);
strokeJoin(ROUND);

// Draw the square.
stroke(0);
squareX = (width - squareWidth) / 2;
squareY = (height - squareWidth) / 2;
rect(squareX, squareY, squareWidth, squareWidth);
println("Square area: " + pow(squareWidth, 2) + " pixels^2");

// Draw a circle inside the square.
stroke(100, 100, 255);
circleX = width/2;
circleY = height/2;
circleDiameter = squareWidth;
ellipse(circleX, circleY, circleDiameter, circleDiameter);
println("Circle area: " + (PI * pow(circleDiameter/2, 2) + " pixels^2"));

// Draw an equilateral triangle in the circle, pointing up.
stroke(255, 100, 100);
triangle(circleX, 
        squareY, 
         circleX-(cos(radians(30))*circleDiameter/2), 
         circleY+(sin(radians(30))*circleDiameter/2),
         circleX+(cos(radians(30))*circleDiameter/2), 
         circleY+(sin(radians(30))*circleDiameter/2)
        );
println("Triangle area: " + (0.5 * pow(squareWidth, 2)) + " pixels^2");

// Draw a dot in the center.
stroke(0);
point(circleX, circleY);

save("../../../../../web/c03types/circumscribedTriangle.png");
