/**
 * Construction draws a scalable construction set for
 * the golden ratio (see http://en.wikipedia.org/wiki/Golden_ratio)
 *
 * @author kvlinden
 * @version Fall, 2009
 */

// Iteration 1
//size(400, 400);
//background(255);
//fill(242, 222, 117);
//rect(100, 100, 200, 200);

// Iteration 2 (add scalability)
//int a = 200, border = a/2;
//size(a + 2*border, a + 2*border);
//background(255);
//fill(242, 222, 117);
//strokeWeight(2);
//stroke(255, 0, 0);
//rect(a/2, a/2, a, a); // Draw original square.

// Iteration 3 (add the PHI constant)
//final float PHI = 1.6180339887;
//int a = 200, border = a/2;
//size(a + (2 * border), floor(a * PHI) + (2 * border));
//background(255);
//smooth();
//fill(242, 222, 117);
//strokeWeight(2);
//stroke(0);
//rect(a/2, (a/2) + a, a, (a * PHI) - a); // Draw added square.
//stroke(255, 0, 0);
//rect(a/2, a/2, a, a);                   // Draw original square.

// Iteration 4 (add the PHI constant)
final float PHI = 1.6180339887;
int a = 400, border = a/2;
float radius = sqrt(pow(a,2) + pow(a/2,2));
size(a + 2 * border, (int)(a * PHI) + 2 * border);
background(255);
smooth();
fill(242, 222, 117);
strokeWeight(2);
stroke(0);
rect(a/2, a/2 + a, a, a * PHI - a); // Draw added square.
stroke(255, 0, 0);
rect(a/2, a/2, a, a);             // Draw original square.

strokeWeight(1);
noFill();
stroke(255, 0, 0);
rect(a/2, a/2, a, a);
stroke(0);
line(a/2, a, border + a, border + a);
arc(a/2, a, 2 * radius, 2 * radius, radians(325), radians(460));

save("../../../../web/c03types/ratioConstruction.png");

