/**
 * ExpandingFigure displays an expanding/fading figure with
 * mouse-directed restarts and variable starting points, and 
 * a keyboard-directed erase feature.
 *
 * Example sequence possibility:
 *  - Remove smooth() and noFill() for the first example.
 *  - Add noFill(), add smooth().
 *  - Add mousePressed() and then press the mouse three times in the middle 
 *    to smooth out the ellipse gradient.
 *  - Add keypress handlers, use rect() instead of ellipse()
 *
 * @author kvlinden, snelesen
 * @version Fall,2010
 */

final int WIDTH=510, HEIGHT=WIDTH;
int figureX, figureY, figureDiameter; // figure specification values

void setup() {
  size(WIDTH, HEIGHT);
  background(255);
  smooth();
  figureX = WIDTH / 2;
  figureY = HEIGHT / 2;
  figureDiameter = 0;
}

void draw() {
  stroke(constrain(figureDiameter/2, 0, 255));
  noFill();
  figureDiameter += 2;
  //rect(figureX, figureY, figureDiameter, figureDiameter);
  ellipse(figureX, figureY, figureDiameter, figureDiameter);
}

/**
 * Press the mouse anywhere to restart the expanding figure centered at that point.
 */
void mousePressed() {
  figureX = mouseX;
  figureY = mouseY;
  figureDiameter = 0;
}

/**
 * Press any key to erase the board.
 */
void keyPressed() {
  save("gradient.png");
  background(255);
}
