/**
 * A quadratic equation of the form ax^2 + bx + c has real roots
 * if its discriminant, b^2-4ac, is non-negative.
 *
 * Do these versions of hasRealRoots() do the same thing? 
 * If not, why not? If so, which is better?
 */

void setup() {
  double a = 1, b = 1, c = 1;
  println(hasRealRoots1(a, b, c));
  println(hasRealRoots2(a, b, c));
}

boolean hasRealRoots1(double a, double b, double c) {
  if ((b*b - 4*a*c) >= 0) {
    return true;
  } else {
    return false;
  }
}

boolean hasRealRoots2(double a, double b, double c) {
  return (b*b - 4*a*c) >= 0;
}
