package c07repetition.lecture.tree;

import processing.core.PApplet;

/**
 * Tree draws a tree fractal using recursion. (reference: Curran Kelleher,
 * "Recursive Structures and Processes", MIT, 2007)
 * 
 * @author kvlinden
 * @version Fall, 2009
 * @version ported to Java, Spring, 2012
 */
public class TreePanel extends PApplet {

	final int N = 16;
	int n;

	public void setup() {
		size(800, 800);
		frameRate(5);
		smooth();
		n = 0;
	}

	public void draw() {
		background(255);
		drawTree(width / 2, height, height * 0.4f, PI / 2, n);
		if (n < N) {
			n++;
		} else {
			stop();
		}
	}

	private void drawTree(float x1, float y1, float length, float angle, int depth) {
		float x2 = x1 - cos(angle) * length;
		float y2 = y1 - sin(angle) * length;
		if (depth < 10) {
			stroke(0, 200, 0);
			strokeWeight(1);
		} else {
			stroke(95, 75, 50);
			strokeWeight(depth - 8);
		}
		line(x1, y1, x2, y2);
		if (depth > 0) {
			drawTree(x2, y2, length * 0.592f, angle + PI / 4, depth - 1);
			drawTree(x2, y2, length * 0.592f, angle - PI / 4, depth - 1);
		}
	}

}
