/** 
 * AreaApproximator animates the approximation of the definite integral of 
 * f(x)=sqrt(x) from 0 to 1.
 *
 * @author kvlinden
 * @version Fall, 2009
 */

int width = 300, height = width;
int xAxis = height-25, yAxis = 25;
float xMax = 1.0, scale = (width - yAxis) / xMax, xMin = -yAxis / scale;
int n;
float area;

void setup() {
  size(width, height);
  background(255);
  n = 1;
//  noLoop();
  frameRate(4);
}

void draw() {
  background(255);
  drawAxes(xAxis, yAxis);
  plotFunction();
  area = drawApproximationRectangles(n++);
  println(area);
  if (n > 100) noLoop();
}

float drawApproximationRectangles(int n) {
  float result = 0;
  float x, y, rectangleWidth = xMax / n;
  for (int i = 0; i < n; i++) {
    x = i * rectangleWidth;
    y = computeY(x);
    plotRectangle(x, y, rectangleWidth, y);
    result += rectangleWidth * y;
  }
  return result;
}

void plotRectangle(float x, float y, float width, float height) {
  fill(168, 128, 234);
  rect(translateX(x), translateY(y), 
  translateDistance(width), translateDistance(height));
}

void plotFunction() {
  stroke(0);
  for (float x = 0; x <= xMax; x += 0.0001) {
    plotPoint(x, computeY(x)); 
  }
}

void plotPoint(float x, float y) {
  point(translateX(x), translateY(y));
}

float translateDistance(float value) {
  return value * scale;
}

float translateX(float value) {
  return value * scale + yAxis;
}

float translateY(float value) {
  return value * -1 * scale + xAxis;
}

float computeY(float x) {
  return sqrt(x);
}

void drawAxes(int x, int y) {
  stroke(200);
  line(0, xAxis, width, xAxis); // x axis
  line(yAxis, 0, yAxis, height); // y axis
}


