int width = 300, height = width;
int xAxis = height*2/3, yAxis = width/3;
float xMax = 1.0, scale = (width - yAxis) / xMax, xMin = -yAxis / scale;

void setup() {
  size(width, height);
  background(255);
  drawAxes(xAxis, yAxis);
  drawLine(.5, 0.5);
}

void drawLine(float m, float b) {
  stroke(0);
  line(0, translate(computeY(m, xMin, b)), width, translate(computeY(m, xMax, b)));
}

float translate(float value) {
  return value * -1 * scale + xAxis;
}

float computeY(float m, float x, float b) {
  return m * x + b;
}

void drawAxes(int x, int y) {
  stroke(200);
  line(0, xAxis, width, xAxis); // x axis
  line(yAxis, 0, yAxis, height); // y axis
}

