package c07repetition.text.mathLibrary;

public class MathLibrary {

	public static int computeGCD(int a, int b) throws Exception {
		if ((a <= 0) || (b <= 0)) {
			throw new Exception("illegal values: " + a + ", " + b);
		}
		int remainder = 1;
		while (remainder != 0) {
			remainder = a % b;
			if (remainder == 0) {
				return b;
			} else {
				a = b;
				b = remainder;
			}
		}
		return 0;
	}

	public static double computeFactorial(int x) throws Exception {
		if (x < 0) {
			throw new Exception("illegal value: " + x);
		}
		if ((x == 1) || (x == 0)) {
			return 1.0;
		} else {
			return x * computeFactorial(x - 1);
		}
	}
	
	public static int computeFibonacci(int n) throws Exception {
		if (n < 0) {
			throw new Exception("invalid fibonacci n: " + n);
		} else if (n > 1) {
			return computeFibonacci(n - 1) + computeFibonacci(n - 2);
		} else {
			return 1;
		}
	}

}
