package c07repetition.text.mathLibrary;

import static org.junit.Assert.*;

import org.junit.Test;

public class MathTest {

	private static final double DOUBLE_EPSILON = 1e-3;

	@Test
	public void gcdTest() {
		try {
			assertEquals(4, MathLibrary.computeGCD(36, 16));
			assertEquals(4, MathLibrary.computeGCD(36, 16));
			assertEquals(4, MathLibrary.computeGCD(36, 16));
		} catch (Exception e) {
			fail("Should not throw an error");
		}
		try {
			MathLibrary.computeGCD(-1, 2);
			fail("Should throw an error");
		} catch (Exception e) {
		}
	}

	@Test
	public void factorialTest() {
		try {
			assertEquals(1.0, MathLibrary.computeFactorial(0), DOUBLE_EPSILON);
			assertEquals(1.0, MathLibrary.computeFactorial(1), DOUBLE_EPSILON);
			assertEquals(6.0, MathLibrary.computeFactorial(3), DOUBLE_EPSILON);
		} catch (Exception e) {
			fail("Should not throw an error");
		}
		try {
			MathLibrary.computeFactorial(-1);
			fail("Should throw an error");
		} catch (Exception e) {
		}
	}

	@Test
	public void fibonacciTest() {
		try {
			assertEquals(1, MathLibrary.computeFibonacci(0));
			assertEquals(1, MathLibrary.computeFibonacci(1));
			assertEquals(89, MathLibrary.computeFibonacci(10));
		} catch (Exception e) {
			fail("Should not throw an error");
		}
		try {
			MathLibrary.computeFibonacci(-1);
			fail("Should throw an error");
		} catch (Exception e) {
		}
	}

}
