/* polygonArea approximates the area of a circle using triangles.
 *
 * @author kvlinden, snelesen
 * @version aug2010
 */

final int WIDTH = 300, HEIGHT = WIDTH; 
int polygonX = WIDTH / 2, polygonY = HEIGHT / 2, polygonDiameter = WIDTH, polygonRadius = polygonDiameter / 2;
int numSides;

void setup() {
  size(WIDTH, HEIGHT);
  smooth();
  numSides = 4;
  frameRate(4);
}

void draw() {
  background(255);
  //ellipse(polygonX, polygonY, polygonDiameter, polygonDiameter);
  strokeWeight(5);
  point(polygonX, polygonY);
  float area = drawPolygon(numSides+=2);
  println("Area - actual = " + PI * polygonRadius * polygonRadius + " approximate = " + area);
}

float drawPolygon(int sides) {
  if (sides < 2) {
    println("invalid number of sides: " + sides + "\nsimplePolygon exiting");
    exit();
  }
  float angle = 360.0 / sides, theta1, theta2;
  strokeWeight(1);
  for (int i = 0; i < sides; i = i+1) {
    if (i % 2 == 0) {
      fill(random(255), random(255), random(255));
    } else {
      fill(0);
    }
    theta1 = radians(angle * i);
    theta2 = radians(angle * (i + 1));
    triangle(polygonX, polygonY, 
    polygonX + cos(theta1) * polygonRadius, 
    polygonY + sin(theta1) * polygonRadius, 
    polygonX + cos(theta2) * polygonRadius, 
    polygonY + sin(theta2) * polygonRadius);
  }
  // Compute area using regular polygon area formula.
  return (sides * polygonRadius * polygonRadius * sin(2 * PI / sides)) / 2.0;
}

void keyPressed() {
  save("../../../../text/c05control/polygonArea.tif");
}







