/* simpleEllipses allows the user to change the color of ellipses, either
 * in the circles or outside of it.
 *
 * @author kvlinden, snelesen
 * @version aug2010
 */
 
final int WIDTH = 300, HEIGHT = WIDTH;
int ellipseX, ellipseY, ellipseDiameter, ellipseRadius, ellipse2Diameter, ellipse2Radius;
color ellipseColor, ellipse2Color, backgroundColor;

void setup() {
  size(WIDTH, HEIGHT);
  smooth();
  ellipseX = WIDTH / 2; 
  ellipseY = HEIGHT / 2;
  ellipseDiameter = 150;
  ellipseRadius = ellipseDiameter / 2;
  ellipse2Diameter = 75;
  ellipse2Radius = ellipse2Diameter / 2;
  ellipseColor = ellipse2Color = backgroundColor = color(255);
}

void draw() {
  background(backgroundColor);
  strokeWeight(2);
  fill(ellipseColor);
  ellipse(ellipseX, ellipseY, ellipseDiameter, ellipseDiameter);
  fill(ellipse2Color);
  ellipse(ellipseX, ellipseY, ellipse2Diameter, ellipse2Diameter);
  strokeWeight(5);
  point(ellipseX, ellipseY);
}

void mouseClicked() {
  if (dist(mouseX, mouseY, ellipseX, ellipseY) <= ellipse2Radius) {
    ellipse2Color = color(random(255), random(255), random(255));
  } 
  else if (dist(mouseX, mouseY, ellipseX, ellipseY) <= ellipseRadius) {
    ellipseColor = color(random(255), random(255), random(255));
  } 
  else {
    backgroundColor = color(random(255), random(255), random(255));
  }
}

void keyPressed() {
  save("simpleEllipses.tif");
}
