/**
 * simpleFlag draws a simplified version of the USA flag.
 * (see usa flag in chapter 3 examples for scaled USA flag).
 *
 * @author kvlinden, snelesen
 * @version aug2010
 */

final int WIDTH=500, HEIGHT=WIDTH/2;
final int COUNT = 13;

void setup() {
  size(WIDTH, HEIGHT);
  noStroke();
  noLoop();
}

void draw() {
  // Draw the stripes.
  for (int i = 0; i < COUNT; i++) {
    if (i % 2 == 0) {
      fill(191, 10, 48);
    } 
    else {
      fill(255);
    }
    rect(0, i * height/COUNT, width-1, height/COUNT);
  }

  // Draw the stars.
  fill(0, 40, 104);
  rect(0, 0, 190, 134);
  stroke(255);
  strokeWeight(5);
  for (int row = 0; row < 9; row++ ) {
    for (int column = 0; column < 11; column++) {
      if ((row%2==0 && column%2==0) || (row%2!=0 && column%2!=0)) {
        point(column*190/11 + 10, row*134/9 + 5);
      }
    }
  }
}

void keyPressed() {
  save("../../../../web/c05control/flag.png");
}