/** 
 * FractalCircles draws a circle fractal using recursion.
 *
 * @author kvlinden
 * @version Spring, 2010
 */

final int WIDTH = 300, HEIGHT = WIDTH;
final int LIMIT = 1;

void setup() {
  size(WIDTH, HEIGHT);
  smooth();
  noLoop();
}

void draw() {
  drawCircles(WIDTH/2, HEIGHT/2, WIDTH);
}

void drawCircles(int x, int y, int diameter) {
  ellipse(x, y, diameter, diameter);
  if (diameter > LIMIT) {
    drawCircles(x - diameter/4, y, diameter/2);
    drawCircles(x + diameter/4, y, diameter/2);
//    drawCircles(x, y - diameter/4, diameter/2);
//    drawCircles(x, y + diameter/4, diameter/2);
  }
}

void keyPressed() {
  save("../../../../text/c05control/fractalCircles.tif");
}
