/**
 * CountryNameConversion replaces the ISO country code in countryData.txt with the official 
 * country name specified for that code in countryCodes.txt.
 *
 * @author kvlinden
 * @version Spring, 2010
 */
 
String[] countryISOCodes, countryData, countryOutputLines;

void setup() {
  countryISOCodes = loadStrings("countryCodes.txt");
  countryData = loadStrings("countryData.txt");
  countryOutputLines = new String[countryData.length];
  String[] tokens;
  for (int i = 0; i < countryData.length; i++) {
    tokens = split(countryData[i], " ");
    countryOutputLines[i] = findCountryName(tokens[0], countryISOCodes) + " " + tokens[1];
  }
  saveStrings("data/countryDataOut.txt", countryOutputLines);
}

/**
 * Finds the country name associated with a given country code
 *
 * @param countryCode - the country code to search for
 * @param countryCodeLines - the table of code-name pairs
 * @return the country name or the original country code if no name is found.
 */
String findCountryName(String countryCode, String[] countryCodeLines) {
  for (int i = 0; i < countryCodeLines.length; i++) {
    if (countryCodeLines[i].substring(0,2).equals(countryCode)) {
      return countryCodeLines[i].substring(3, countryCodeLines[i].length());
    }
  }
  return countryCode;
}
