/**
 * Raindrops models a number of falling raindrops.
 * cf. Dan Shiffman, chapter 10
 *
 * @author kvlinden
 * @version Fall, 2009
 */

final int DROP_COUNT = 1000, DROP_DIAMETER = 10, DROP_VELOCITY = 5;

Drop[] drops;
float phaseIn;  // Allows program to add drop objects one at a time

void setup() {
  size(400, 600);
  background(255);
  smooth();
  drops = new Drop[DROP_COUNT];
  for (int i = 0; i < drops.length; i++) {
    drops[i] = new Drop(random(DROP_DIAMETER, width - DROP_DIAMETER), DROP_DIAMETER, DROP_DIAMETER, DROP_VELOCITY);
  }
  phaseIn = 0.0;
}

void draw() {
  background(255);
  for (int i = 0; i < drops.length && i < phaseIn; i++) {
    drops[i].move();
    drops[i].display(height);
    // Check for collosions with other drops.
    for (int j = 0; j < drops.length && j < phaseIn; j++) {
      if (i != j) {
        drops[i].combine(drops[j]);
      }
    }
  }
  phaseIn += 0.5;
}

void keyPressed() {
  save("../../../../text/07classes/rain.tif");
}




