package c10quality.text.raindops;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * RaindropController1 shows an empty raindrops animation with the ability to
 * set the frame rate.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
@SuppressWarnings("serial")
public class RaindropController extends JFrame implements ActionListener {

	RaindropPanel raindropPanel;
	JTextField frameRateField, messageLabel;
	JButton startButton, pauseButton;

	public RaindropController() {
		setTitle("Raindrops");
		setDefaultCloseOperation(EXIT_ON_CLOSE);

		// the raindrop animation panel
		raindropPanel = new RaindropPanel(30);
		raindropPanel.init();
		add(raindropPanel, BorderLayout.NORTH);

		// a control panel
		JPanel controlPanel = new JPanel(new FlowLayout());
		startButton = new JButton("Start");
		startButton.setEnabled(false);
		startButton.addActionListener(this);
		//controlPanel.add(startButton);
		pauseButton = new JButton("Pause");
		pauseButton.setEnabled(true);
		pauseButton.addActionListener(this);
		//controlPanel.add(pauseButton);
		controlPanel.add(new JLabel("Frame rate:"));
		frameRateField = new JTextField(3);
		frameRateField.setText("30");
		controlPanel.add(frameRateField);
		frameRateField.addActionListener(this);
		add(controlPanel, BorderLayout.CENTER);
		
		messageLabel = new JTextField("Welcome...");
		messageLabel.setEditable(false);
		//add(messageLabel, BorderLayout.SOUTH);
	}

	@Override
	public void actionPerformed(ActionEvent event) {
		// System.out.println(e.getActionCommand());
		if (event.getActionCommand().equalsIgnoreCase("start")) {
			raindropPanel.setRunning(true);
			startButton.setEnabled(false);
			pauseButton.setEnabled(true);
		} else if (event.getActionCommand().equalsIgnoreCase("pause")) {
			raindropPanel.setRunning(false);
			startButton.setEnabled(true);
			pauseButton.setEnabled(false);
		} else {
			try {
				int newFrameRate = Integer.parseInt(frameRateField.getText());
				raindropPanel.setFrameRate(newFrameRate);
			} catch (Exception exception) {
				frameRateField.setText("");
				messageLabel.setText(exception.getMessage());
			}
		}
	}

	public static void main(String[] args) {
		RaindropController controller = new RaindropController();
		controller.pack();
		controller.setVisible(true);
	}

}
