package c10quality.text.raindops;

import processing.core.PApplet;

/**
 * RaindropPanel is an enhanced Java encapsulation of the original raindrops
 * animation from Processing. It provides start/pause capability.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class RaindropPanel extends PApplet {

	private static final int SIZE = 300;
	private int mySize, myFrameRate, myDiameter;
	private Raindrop raindrop;

	private boolean myRunningStatus;

	// private enum Status {
	// RUNNING, STOPPED
	// };
	// private Status myStatus;

	public RaindropPanel() {
		mySize = SIZE;
		myFrameRate = 30;
		myRunningStatus = true;
	}

	public RaindropPanel(int initialFrameRate) {
		mySize = SIZE;
		myFrameRate = initialFrameRate;
		myRunningStatus = true;
	}

	public void setFrameRate(int frameRate) throws Exception {
		if (frameRate < 0) {
			throw new Exception("Bad framerate: " + frameRate);
		}
		myFrameRate = frameRate;
	}

	public void setRunning(boolean running) {
		myRunningStatus = running;
	}

	public void setup() {
		size(mySize, mySize);
	}

	public void draw() {
		if (myRunningStatus) {
			frameRate(myFrameRate);
			raindrop = new Raindrop(random(mySize), random(mySize), random(mySize / 2), color(
					random(255), random(255), random(255), random(255)));
			raindrop.render(this);
			// fill(random(255), random(255), random(255), random(255));
			// myDiameter = (int) random(mySize / 2);
			// ellipse(random(mySize), random(mySize), myDiameter, myDiameter);
		}
	}

	public void mousePressed() {
		background(200);
	}

}
