package c10quality.text.temperatureEnumeration;

import c10quality.text.temperatureEnumeration.Temperature.Scale;

/**
 * This version of the temperature controller handles thrown exceptions.
 * 
 * @author kvlinden
 * @version Spring, 2012
 */
public class TemperatureConsole {

	public static void main(String[] args) {
		Temperature temperature1 = null;
		try {
			temperature1 = new Temperature(98.6, Scale.FAHRENHEIT);
			System.out.println(temperature1.getDegrees());
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}

		try {
			Temperature temperature3 = new Temperature(-1.0, Scale.KELVIN);
			System.out.println(temperature3.getDegrees());
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}

		try {
			temperature1.change(-1000.0);
			System.out.println("We should never get here!");
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}

	}
}
