package c10quality.text.temperatureEnumeration;

import static c10quality.text.temperatureEnumeration.Temperature.Scale;

import java.util.InputMismatchException;
import java.util.Scanner;

/**
 * TemperatureConverterConsole implements a simple text-based interface for the
 * temperature converter application.
 * 
 * @author kvlinden
 * @version Fall, 2012
 */
public class TemperatureConverterConsole {

	public static void main(String[] args) {
		System.out.print("Enter a temperature (e.g., 98.6 F): ");
		// System.out.print("Enter a temperature: ");

		Scanner scanner = new Scanner(System.in);
		try {
			double degrees = scanner.nextDouble();
			Temperature.Scale scale = readScale(scanner);
			Temperature temperature = new Temperature(degrees, scale);
			System.out.print("Convert to: ");
			temperature.setScale(readScale(scanner));
			System.out.println("Result: " + temperature);
		} catch (InputMismatchException e) {
			System.out.println("Please enter a valid degree value of the form 98.6 F.");
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
	}
	
	// Read char scale from the keyboard and convert to Temperature.Scale.
	public static Scale readScale(Scanner scanner) throws Exception {
		char scaleInput = scanner.next().charAt(0);
		if (Character.toUpperCase(scaleInput) == 'C') {
			return Scale.CELSIUS;
		} else if (Character.toUpperCase(scaleInput) == 'F') {
			return Scale.FAHRENHEIT;
		} else if (Character.toUpperCase(scaleInput) == 'K') {
			return Scale.KELVIN;
		} else {
			throw new Exception("Invalid scale: " + scaleInput);
		}
		
	}

}
