package c10quality.text.temperatureGUI;

public class Temperature0 {
	
	private double myDegrees;
	private String myScale;
	
	public Temperature0() {
		myDegrees = 0.0;
		myScale = "celsius";
	}
	
	public Temperature0(double degrees, String scale) {
		myDegrees = degrees;
		myScale = scale.toLowerCase();
	}
	
	public double getDegrees() {
		return myDegrees;
	}

	public String getScale() {
		return myScale;
	}
	
	public void setScale(String scale) {
		if (scale.equalsIgnoreCase("celsius")) {
			convertToCelsius();
		} else if (scale.equalsIgnoreCase("fahrenheit")) {
			convertToFahrenheit();
		} else if (scale.equalsIgnoreCase("kelvin")) {
			convertToKelvin();
		}
	}
	
	private void convertToCelsius() {
		if (myScale.equals("fahrenheit")) {
			myDegrees = 5.0 / 9.0 * (myDegrees - 32.0);
		} else if (myScale.equals("kelvin")) {
			myDegrees = myDegrees - 273.15;
		}
		myScale = "celsius";
	}

	private void convertToFahrenheit() {
		if (myScale.equals("celsius")) {
			myDegrees = myDegrees * 1.8 + 32.0;
		} else if (myScale.equals("kelvin")) {
			myDegrees = (myDegrees - 273.15) * 1.8 + 32.0;
		}
		myScale = "fahrenheit";
	}

	private void convertToKelvin() {
		if (myScale.equals("celsius")) {
			myDegrees = myDegrees + 273.15;
		} else if (myScale.equals("fahrenheit")) {
			myDegrees = 5.0 / 9.0 * (myDegrees - 32.0) + 273.15;
		}
		myScale = "kelvin";
	}
	
	public String toString() {
		return getDegrees() + " " + Character.toUpperCase(getScale().charAt(0));
	}

}
