package c10quality.text.temperatureGUI;

import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class Temperature0ConverterController extends JFrame implements
		ActionListener {

	private Temperature0 temperature;
	private JTextField celsiusField, fahrenheitField, kelvinField;

	public Temperature0ConverterController() {
		setTitle("Temperature Converter");
		setDefaultCloseOperation(EXIT_ON_CLOSE);

		setLayout(new GridLayout(3, 1));
		Font font = new Font("Ariel", 0, 18);
		celsiusField = new JTextField(7);
		add(createTemperatureControl("Celsius", celsiusField, font));
		fahrenheitField = new JTextField(7);
		add(createTemperatureControl("Fahrenheit", fahrenheitField, font));
		kelvinField = new JTextField(7);
		add(createTemperatureControl("Kelvin", kelvinField, font));
	}

	private JPanel createTemperatureControl(String name, JTextField field,
			Font font) {
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(1, 2));
		JLabel label = new JLabel(name + ": ", JLabel.RIGHT);
		label.setFont(font);
		panel.add(label);
		field.setFont(font);
		field.setActionCommand(name);
		field.addActionListener(this);
		panel.add(field);
		return panel;
	}

	@Override
	public void actionPerformed(ActionEvent ae) {
		String actionEvent = ae.getActionCommand();
		double degrees;
		if (actionEvent.equalsIgnoreCase("celsius")) {
			degrees = Double.parseDouble(celsiusField.getText());
		} else if (actionEvent.equalsIgnoreCase("fahrenheit")) {
			degrees = Double.parseDouble(fahrenheitField.getText());
		} else {
			degrees = Double.parseDouble(kelvinField.getText());
		}
		temperature = new Temperature0(degrees, ae.getActionCommand());
		temperature.setScale("celsius");
		celsiusField.setText(doubleToString(temperature.getDegrees()));
		temperature.setScale("fahrenheit");
		fahrenheitField.setText(doubleToString(temperature.getDegrees()));
		temperature.setScale("kelvin");
		kelvinField.setText(doubleToString(temperature.getDegrees()));
	}

	private String doubleToString(double value) {
		DecimalFormat doubleFormat = new DecimalFormat("#.##");
		return doubleFormat.format(value);
	}

	public static void main(String[] args) {
		Temperature0ConverterController controller = new Temperature0ConverterController();
		controller.pack();
		controller.setVisible(true);
	}

}
