package c10quality.text.temperatureGUI;

public class Temperature1 {

	private final static double ABSOLUTE_ZERO_CELSIUS = -273.15,
			ABSOLUTE_ZERO_FAHRENHEIT = -459.67, ABSOLUTE_ZERO_KELVIN = 0.0;

	private double myDegrees;
	private String myScale;

	public Temperature1() {
		myDegrees = 0.0;
		myScale = "celsius";
	}

	public Temperature1(double degrees, String scale) throws Exception {
		if (isValid(degrees, scale)) {
			myDegrees = degrees;
			myScale = scale.toLowerCase();
		} else {
			throw new Exception("Invalid temperature: " + degrees + " " + scale);
		}
	}

	private static boolean isValid(double degrees, String scale) {
		if (scale.equalsIgnoreCase("celsius")) {
			return degrees >= ABSOLUTE_ZERO_CELSIUS;
		} else if (scale.equalsIgnoreCase("fahrenheit")) {
			return degrees >= ABSOLUTE_ZERO_FAHRENHEIT;
		} else if (scale.equalsIgnoreCase("kelvin")) {
			return degrees >= ABSOLUTE_ZERO_KELVIN;
		} else {
			return false;
		}
	}

	public double getDegrees() {
		return myDegrees;
	}

	public String getScale() {
		return myScale;
	}

	public void setScale(String scale) throws Exception {
		if (scale.equalsIgnoreCase("celsius")) {
			convertToCelsius();
		} else if (scale.equalsIgnoreCase("fahrenheit")) {
			convertToFahrenheit();
		} else if (scale.equalsIgnoreCase("kelvin")) {
			convertToKelvin();
		} else {
			throw new Exception("Invalid scale: " + scale);
		}
	}

	private void convertToCelsius() {
		if (myScale.equals("fahrenheit")) {
			myDegrees = 5.0 / 9.0 * (myDegrees - 32.0);
		} else if (myScale.equals("kelvin")) {
			myDegrees = myDegrees - 273.15;
		}
		myScale = "celsius";
	}

	private void convertToFahrenheit() {
		if (myScale.equals("celsius")) {
			myDegrees = myDegrees * 1.8 + 32.0;
		} else if (myScale.equals("kelvin")) {
			myDegrees = (myDegrees - 273.15) * 1.8 + 32.0;
		}
		myScale = "fahrenheit";
	}

	private void convertToKelvin() {
		if (myScale.equals("celsius")) {
			myDegrees = myDegrees + 273.15;
		} else if (myScale.equals("fahrenheit")) {
			myDegrees = 5.0 / 9.0 * (myDegrees - 32.0) + 273.15;
		}
		myScale = "kelvin";
	}
	
	public String toString() {
		return getDegrees() + " " + Character.toUpperCase(getScale().charAt(0));
	}

}
