package c11ui.lecture.scribbler;

import processing.core.PApplet;

public class ScribblerPanel extends PApplet {
	
	private final int RANGE = 5;
	private float x, y, oldX, oldY, myStrokeWeight;
	private int myWidth, myHeight;
	
	public ScribblerPanel() {
		myStrokeWeight = 1;
		myWidth = myHeight = 400;
	}
	
	public ScribblerPanel(int strokeWeight, int size) {
		myStrokeWeight = strokeWeight;
		myWidth = myHeight = size;
	}

	public void setup() {
	  size(myWidth, myHeight);
	  oldX = myWidth/2;
	  oldY = myHeight/2;
	  background(255);
	  strokeWeight(myStrokeWeight);
	}

	public void draw() {
	  x = constrain(oldX + random(-RANGE, RANGE), 0, myWidth);
	  y = constrain(oldY + random(-RANGE, RANGE), 0, myHeight);
	  line(oldX, oldY, x, y);
	  oldX = x;
	  oldY = y;  
	}

	public void mousePressed() {
	  oldX = mouseX;
	  oldY = mouseY;
	}

}
