package c11ui.lecture.shaker.shaker1;

import processing.core.PApplet;

/**
 * ShakerPanel is a simple Java encapsulation of the original shaker
 * animation from Processing. It draws a shaking circle and allows the 
 * user to reposition the circle using a mouse click.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class ShakerPanel extends PApplet {

	private static final int SIZE = 300;
	private int myX, myY, myShift;

	public ShakerPanel() {
		myX = myY = SIZE / 2;
		myShift = 5;
	}

	public void setup() {
		size(SIZE, SIZE);
		smooth();
	}

	public void draw() {
		background(255);
		strokeWeight(2);
		ellipse(myX + random(-myShift / 2, myShift / 2), myY + random(-myShift / 2, myShift / 2),
				50, 50);
	}

	public void mousePressed() {
		myX = mouseX;
		myY = mouseY;
	}

}
