package c11ui.lecture.shaker.shaker2;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JTextField;

/**
 * ShakerController is a upgraded version of a Java controller for the
 * Processing raindrops application. It provides a shift-rate field controller.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class ShakerController extends JFrame {

	private ShakerPanel shakerPanel;
	private JTextField shiftField;

	public ShakerController() {
		setTitle("Shaker");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setLayout(new BorderLayout());

		shakerPanel = new ShakerPanel();
		shakerPanel.init();
		add(shakerPanel, BorderLayout.NORTH);

		shiftField = new JTextField(3);
		shiftField.setText(String.format("%d", shakerPanel.getShift()));
		shiftField.addActionListener(new ShiftFieldListener());
		add(shiftField, BorderLayout.CENTER);
	}

	class ShiftFieldListener implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent ae) {
			try {
				shakerPanel.setShift(Integer.parseInt(shiftField.getText()));
			} catch (Exception e) {
				// Will have to print a message here somehow.
			}			
		}
	}

	public static void main(String[] args) {
		ShakerController controller = new ShakerController();
		controller.pack();
		controller.setVisible(true);
	}

}
