package c11ui.lecture.shaker.shaker3;

import processing.core.PApplet;

/**
 * ShakerPanel3 is an upgraded Java encapsulation of the original shaking circle
 * application. It allows the controller to change the shift rate and to turn
 * the animation on and off.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
@SuppressWarnings("serial")
public class ShakerPanel extends PApplet {

	private static final int SIZE = 300;
	private int myX, myY, myShift;
	private boolean myRunningStatus;

	//constructor
	public ShakerPanel() {
		myX = myY = SIZE / 2;
		myShift = 10;
		myRunningStatus = true;
	}
	
	public void setup() {
		size(SIZE, SIZE);
		smooth();
		background(255);
	}

	public void draw() {
		if (myRunningStatus) {
			background(255);
			// Replace background() with this code for a fading animation.
			// noStroke();
			// fill(255, 25);
			// rect(0, 0, width, height);
			// fill(255);
			// stroke(0);
			strokeWeight(2);
			ellipse(myX + random(-myShift / 2, myShift / 2), myY
					+ random(-myShift / 2, myShift / 2), 50, 50);
		}
	}

	public void mousePressed() {
		myX = mouseX;
		myY = mouseY;
	}
	
	public int getShift() {
		return myShift;
	}

	public void setShift(int shift) throws Exception {
		if (shift < 0) {
			throw new Exception("invalid shift value: " + shift);
		}
		myShift = shift;
	}

	public void setRunning(boolean status) {
		myRunningStatus = status;
	}

	
}
