package c11ui.lecture.shaker.shaker5;

import processing.core.PApplet;

/**
 * Figure is an objectified version of the shaking circle application in
 * Processing. The shift value must be positive.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class Figure {

	private int myX, myY, myDiameter, myShift;

	public Figure() {
		myX = myY = myDiameter = myShift = 0;
	}

	public Figure(int x, int y, int diameter, int shift) throws Exception {
		if (shift < 0) {
			throw new Exception("Invalid shift value: " + shift);
		}
		myX = x;
		myY = y;
		myDiameter = diameter;
		myShift = shift;
	}

	public int getShift() {
		return myShift;
	}

	public void setShift(int shift) throws Exception {
		if (shift < 0) {
			throw new Exception("invalid shift value: " + shift);
		}
		myShift = shift;
	}

	public void setX(int x) {
		myX = x;
	}

	public void setY(int y) {
		myY = y;
	}
	
	public void render(PApplet p) {
		p.strokeWeight(2);
		p.ellipse(myX + p.random(-myShift / 2, myShift / 2),
				myY + p.random(-myShift / 2, myShift / 2), myDiameter, myDiameter);
	}

}
