package c11ui.lecture.shaker.shaker5;

import processing.core.PApplet;

/**
 * ShakerPanel5 upgrades ShakerPanel3 by adding a Figure class.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class ShakerPanel extends PApplet {

	private static final int SIZE = 300;

	private boolean myRunningStatus;
	private Figure myFigure;

	public ShakerPanel() {
		myRunningStatus = true;
	}

	public int getShift() {
		return myFigure.getShift();
	}

	public void setShift(int shift) throws Exception {
		if (shift < 0) {
			throw new Exception("invalid shift value: " + shift);
		}
		myFigure.setShift(shift);
	}

	public void setRunning(boolean status) {
		myRunningStatus = status;
	}

	public void setup() {
		size(SIZE, SIZE);
		smooth();
		try {
			myFigure = new Figure(SIZE / 2, SIZE / 2, 50, 5);
		} catch (Exception e) {
			// We'd better not get here!
		}
	}

	public void draw() {
		if (myRunningStatus) {
			background(255);
			myFigure.render(this);
		}
	}

	public void mousePressed() {
		myFigure.setX(mouseX);
		myFigure.setY(mouseY);
	}
}
