package c11ui.text.expandingCircle.expander2;

import processing.core.PApplet;

/**
 * Expander encapsulates the features of an expanding ellipse.
 * It is decoupled from the ExpanderPanel except in the case of the
 * render() method, which receives a PApplet handle for using 
 * drawing the elements of the figure.
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class Expander {

	private int myX, myY, myDiameter;
	int myColor;
	
	public Expander(int x, int y, int diameter, int color) {
		myX = x;
		myY = y;
		myDiameter = diameter;
		myColor = color;
	}
	
//	public void setDiameter(int diameter) {
//		myDiameter = diameter;
//	}
	
	public void incrementDiameter() {
		myDiameter++;
	}
	
	public void render(PApplet p) {
		p.fill(myColor);
		p.ellipse(myX, myY, myDiameter, myDiameter);
	}
}
