package c11ui.text.raindrops.raindrops1;

import processing.core.PApplet;

/**
 * RaindropPanel is a simple Java encapsulation of the original 
 * raindrops animation from Processing. It draws random figures
 * and allows the user to clear the screen with a mouse click.
 *
 * @author kvlinden
 * @version Fall, 2009
 */
public class RaindropPanel extends PApplet {

	private static final int SIZE = 300;
	private int mySize, myDiameter, myFrameRate;
	
	public RaindropPanel(int frameRate) {
		if (frameRate < 1) {
			System.out.println("illegal frame rate: " + frameRate);
			exit();
		}
		mySize = SIZE;
		myFrameRate = frameRate;
	}

	public void setup() {
		size(mySize, mySize);
		frameRate(myFrameRate);
	}

	public void draw() {
		fill(random(255), random(255), random(255), random(255));
		myDiameter = (int) random(mySize / 2);
		ellipse(random(mySize), random(mySize), myDiameter, myDiameter);
	}

	public void mousePressed() {
		background(200);
	}
}
