package c11ui.text.tipCalculator;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;

@SuppressWarnings("serial")
public class TipCalculatorGUI1 extends JFrame implements ActionListener {

	private static final double TIP_RATE = 0.15;
	
	private JTextField billField, tipField;

	public TipCalculatorGUI1() {
		setTitle("Tip Calculator");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setLayout(new FlowLayout());
		
		// The bill label and text input field
		add(new JLabel("bill:"));
		billField = new JTextField(10);
		add(billField);
		billField.addActionListener(this);
		
		// The tip label and text output field
		add(new JLabel("suggested tip:"));
		tipField = new JTextField(10);
		add(tipField);
	}
	
	@Override
	public void actionPerformed(ActionEvent arg0) {
		double bill = Double.parseDouble(billField.getText());
		double tip = bill * TIP_RATE;
		String tipString = new DecimalFormat("$0.00").format(tip);
		tipField.setText(tipString);	
	}
	
	public static void main(String[] args) {
		TipCalculatorGUI1 controller = new TipCalculatorGUI1();
		controller.pack();
		controller.setVisible(true);
	}

}
