package c12lists.text.Gateway;

/** AddressCounter.java defines a class for storing an IP address and 
 *  its count.  (See GatewayUsageCounter.java.)
 *  Attributes: maximum message length (static), address, and count
 *  Methods:    Construct an AddressCounter from a string representation of
 *              an address; equals() to compare addresses; count incrementer;
 *              accessors of address and count; to-string converter for output
 */

public class AddressCounter extends Object
{
	//--- Attribute variables ---
	 private static int MAX_ADDRESS_LENGTH = 15;  // 12 digits + 3 dots
	 private String     myAddress;
	 private int        myCount;

	 /* AddressCounter constructor
 * Receive:       String anAddress
 * Postcondition: myAddress == anAddress && myCount == 1
 */
 public AddressCounter(String anAddress)
 {
   myAddress = anAddress;
   myCount = 1;
 }

/* equals method
 * Receive: Object anObject
 * Return:  true if this object is same as anObject
 */
// public boolean equals(Object anObject)
// {
//   if (anObject instanceof AddressCounter)
//   {
//     AddressCounter otherCounter = (AddressCounter) anObject;
//     return myAddress.equals( otherCounter.getAddress() );
//   }
//   else
//     return false;
// }

/* method to increment count
 * Postcondition:  myCount is incremented by 1.
 */
public void incrementCount()
 {
   myCount++;
 }

//--- Accessors ---
/* count
 * Return: myCount */
 public int getCount()      { return myCount; }

/* address
 * Return: myAddress */
 public String getAddress() { return myAddress; }

/* String converter -- for output purposes
 * Return: String representing an AddressCounter */
public String toString()
 {
   String spaces = "";
   int spacesNeeded = MAX_ADDRESS_LENGTH - myAddress.length();
   for (int i = 0; i < spacesNeeded; i++)
     spaces += " ";
   return myAddress + spaces + ": " + myCount;
 }

}
