package c12lists.text.characterdrill.characterdrill1;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**
 * CharacterDrill manages a simple quiz with hints based on a manually-created
 * list of Chinese characters.
 * 
 * @author kvlinden
 * @version Fall, 2009
 * @version Revised to remove file handling, Spring, 2012
 */
public class CharacterDrill {

	private List<Character> myCharacters;
	private int myAnswerIndex, myHintCount;

	private Random myRandom;

	public CharacterDrill() {
		myCharacters = new ArrayList<Character>();
		myCharacters.add(new Character("I", "wo3", "\u6211"));
		myCharacters.add(new Character("you", "ni3", "\u4F60"));
		myCharacters.add(new Character("he", "ta1", "\u4ED6"));
		myCharacters.add(new Character("she", "ta1", "\u5979"));
		myCharacters.add(new Character("it", "ta1", "\u5B83"));
		myCharacters.add(new Character("love", "ai4", "\u611B"));
		myCharacters.add(new Character("good", "hao3", "\u597D"));
		myRandom = new Random();
		reset();
	}

	public void reset() {
		myAnswerIndex = myRandom.nextInt(myCharacters.size());
		myHintCount = 0;
	}

	public boolean guess(String guess) {
		return myCharacters.get(myAnswerIndex).getEnglish().equalsIgnoreCase(guess);
	}

	public String getAnswer() {
		return myCharacters.get(myAnswerIndex).getEnglish();
	}

	public String getHintText() throws Exception {
		myHintCount++;
		if (myHintCount == 1) {
			return "Chinese character: " + myCharacters.get(myAnswerIndex).getCharacter();
		} else if (myHintCount == 2) {
			return "PinYin: " + myCharacters.get(myAnswerIndex).getPinyin();
		} else {
			return "No more hints...";
		}
	}

}
