package c13oop.lecture.payrollOld;

/** Manager.java provides a subclass of SalariedEmployee to model 
 *  managers.  New attribute variable stores manager's division.  
 *  Methods: Constructors: default and one to construct a SalariedEmployee
 *           from a name, ID number, salary, and division;   accessors; 
 *           to-string converter for output purposes;  
 *           reader to read a name, ID number, salary, and division
 *  @see SalariedEmployee
 */

import java.util.Scanner;              

class Manager extends SalariedEmployee
{
 //--- Manager default constructor ---
 public Manager()
 {
   super();
   myDivision = "";
 }
  
 //--- Manager explicit-value constructor ---
 public Manager(String name, int id, double salary, String division)
 {
   super(name, id, salary);
   myDivision = division;
 } 
 
 //--- Accessor method ---
 public String division() { return myDivision; }

 //--- String converter (for output) ---
 public String toString() 
 {
   return super.toString() + " " + division();
 }
 
 //--- File input ---
 void read(Scanner reader)
 {
   super.read(reader);
   try
   {
	   reader.nextLine(); // get to next line
	   myDivision = reader.nextLine();	
	   System.out.println(myDivision);
   }
   catch (Exception e)
   {
     System.err.println("Manager:read(): " + e);
     System.exit(1);
   }
 }

 //--- Attribute variable ---
 private String myDivision;
}

