package c13oop.lecture.payrollOld;

/** Paycheck.java provides a class to model paychecks.
 *  New attribute variables store a name, check amount, and ID number.
 *  Methods: Constructors: to construct a Paycheck from an Employee
 *           accessors; to-string converter for output purposes;  
 *  @see Employee
 */

import java.text.*;        // NumberFormat

class Paycheck extends Object
{
 //--- Paycheck constructor ---
 public Paycheck(Employee employee)
 {
   myName   = employee.name();
   myAmount = employee.pay();
   myID     = employee.id();
 }

 //--- Accessor methods ---
 public String name()   { return myName; }
 public double amount() { return myAmount; }
 public int id()        { return myID; }

 //--- String converter (for output) ---
 public String toString()
 {
   NumberFormat cf = NumberFormat.getCurrencyInstance();
   String formattedAmount = cf.format(myAmount);
   return myName + "\t\t" + formattedAmount + "\n" + myID;
 }

 //--- Attribute variables ---
 private String myName;
 private double myAmount;
 private int    myID;
}