package c13oop.text.simpledraw.simpledraw0;

import java.awt.Point;

import processing.core.PApplet;

/**
 * A simple rectangle class
 * 
 * This sort of stand-alone class approach doesn't scale well. For example,
 * consider how hard it would be to modify this class (and all other related
 * figure classes) to receive two defining points rather than a point and a
 * width/height pair).
 * 
 * @author kvlinden
 * @version Fall, 2009
 */
public class Rectangle {

	private Point myStart;
	private int myColor;
	private int myWidth, myHeight;
	private boolean myFilled;

	public Rectangle(Point start, int width, int height, int color, boolean filled) {
		myStart = start;
		myColor = color;
		myWidth = width;
		myHeight = height;
		myFilled = filled;
	}
	
	public int getColor() {
		return myColor;
	}
	public void setColor(int color) {
		myColor = color;
	}

	public void render(PApplet p) {
		p.stroke(myColor);
		if (myFilled) {
			p.fill(myColor);
		} else {
			p.noFill();
		}
		p.rect(myStart.x, myStart.y, myWidth, myHeight);
	}
}
