package c13oop.text.simpledraw.simpledraw1;

import java.awt.Point;

import processing.core.PApplet;
import processing.core.PConstants;

public class Ellipse extends ClosedFigure {

	public Ellipse(Point start, int color, boolean filled) {
		super(start, color, filled);
	}

	public Ellipse(Point start, Point end, boolean filled) {
		super(start, end.x - start.x, end.y - start.y, filled);
	}

	public Ellipse(Point start, Point end, int color, boolean filled) {
		super(start, color, end.x - start.x, end.y - start.y, filled);
	}

	public void updatePoint(Point p) {
		setWidth(p.x - getStart().x);
		setHeight(p.y - getStart().y);
	}

	public void render(PApplet p) {
		p.stroke(getColor());
		p.ellipseMode(PConstants.CORNER);
		if (getFilled()) {
			p.fill(getColor());
		}
		p.ellipse(getStart().x, getStart().y, getWidth(), getHeight());
	}
}
