package c13oop.text.simpledraw.simpledraw1;

import java.awt.Point;

import processing.core.PApplet;

public class Rectangle extends ClosedFigure {

	public Rectangle(Point start, Point end, boolean filled) {
		super(start, end.x - start.x, end.y - start.y, filled);
	}

	public Rectangle(Point start, int color, boolean filled) {
		super(start, color, filled);
	}

	public Rectangle(Point start, Point end, int color, boolean filled) {
		super(start, color, end.x - start.x, end.y - start.y, filled);
	}
	
	public Rectangle(Point start, int width, int height, int color, boolean filled) {
		super(start, color, width, height, filled);
	}

	public void updatePoint(Point p) {
		setWidth(p.x - getStart().x);
		setHeight(p.y - getStart().y);
	}

	public void render(PApplet p) {
		p.stroke(getColor());
		if (getFilled()) {
			p.fill(getColor());
		} else {
			p.noFill();
		}
		p.rect(getStart().x, getStart().y, getWidth(), getHeight());
	}
}
