package c13oop.text.simpledraw.simpledraw2;

import java.awt.Point;

import processing.core.PApplet;
import processing.core.PConstants;

public class Ellipse extends ClosedFigure {

	public Ellipse(Point start, int color, boolean filled) {
		super(start, color, filled);
	}
	
	public Ellipse(Point start, Point end, int color, boolean filled) {
		super(start, color, end.x - start.x, end.y - start.y, filled);
	}
	
	public void updatePoint(Point p) {
		myWidth = p.x - myStart.x;
		myHeight = p.y - myStart.y;
	}
	
	public void render(PApplet p) {
		p.stroke(myColor);
		p.ellipseMode(PConstants.CORNER);
		if (myFilled) {
			p.fill(myColor);
		}
		p.ellipse(myStart.x, myStart.y, myWidth, myHeight);
	}
}
